<template>
    <div>
        <template v-if="$route.name==='home'">


    <!--important -->
            <div v-if="!loading" v-for="(country_league, idx) in sortWeightName(mainLeagues)" :key="idx" class="box no-padding box-table">
                <div class="box-table-headinfo">
                    <div class="topline mb0">
                        <div class="country">
                            <div :class="[
                        'flag',
                        'flag-icon',
                        `flag-icon-${country_league.iso_2.toLowerCase() || 'placeholder'}`
                    ]"></div>
                            <div class="name">{{ country_league.name }}</div>
                        </div>
                        <div class="toggler">
                            <svg> <use xlink:href="#arr-down"/> </svg>
                        </div>
                    </div>
                </div>

                <country-league
                    v-if="!leagueLoading"
                    :league="country_league.league"
                    :date-matches-bets="dateMatches.bets"
                    :display-only-important-leagues="false"
                />
                <horizontal-loader v-if="leagueLoading" />
            </div>
            <!--rest -->
            <div v-if="!loading" v-show="displayAllLeagues" v-for="(country_league, idx) in sortWeightName(restLeagues)" :key="getKey(idx)" class="box no-padding box-table">
                <div class="box-table-headinfo">
                    <div class="topline mb0">
                        <div class="country">
                            <div :class="[
                        'flag',
                        'flag-icon',
                        `flag-icon-${country_league.iso_2.toLowerCase() || 'placeholder'}`
                    ]"></div>
                            <div class="name">{{ country_league.name }}</div>
                        </div>
                        <div class="toggler">
                            <svg> <use xlink:href="#arr-down"/> </svg>
                        </div>
                    </div>
                </div>
                <country-league
                    v-if="!leagueLoading"
                    :league="country_league.league"
                    :date-matches-bets="dateMatches.bets"
                    :display-only-important-leagues="false"
                />

                <horizontal-loader v-if="leagueLoading" />
            </div>

        </template>
        <template v-else>
            <div v-if="!loading" v-for="(country, idx) in sortNameCountries(dateMatches.data)" :key="idx" class="box no-padding box-table">
                <div class="box-table-headinfo">
                    <div class="topline mb0">
                        <div class="country">
                            <div :class="[
                        'flag',
                        'flag-icon',
                        `flag-icon-${country.iso_2.toLowerCase() || 'placeholder'}`
                    ]"></div>
                            <div class="name">{{ country.name }}</div>
                        </div>
                        <div class="toggler">
                            <svg> <use xlink:href="#arr-down"/> </svg>
                        </div>
                    </div>
                </div>

                <country-league
                    v-if="!leagueLoading"
                    v-for="(league, leagueIdx) in sortLeagues(country)"
                    :league="league"
                    :key="leagueIdx"
                    :date-matches-bets="dateMatches.bets"
                    :display-only-important-leagues="displayOnlyImportantLeagues"
                />

                <horizontal-loader v-if="leagueLoading" />
            </div>
        </template>
        <div class="loader-wrapper">
            <div class="lds-roller" v-if="loader"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>

        </div>
        <loader v-if="loading" />

<!--        <div v-if="!loading && displayOnlyImportantLeagues" class="flex aic jcc">-->
<!--            <button @click="showAllLeagues" class="btn show-all"> <span class="text">Show More</span>-->

<!--            </button>-->
<!--        </div>-->

        <div v-if="!loading && !Object.keys(dateMatches).length" class="no-matches text-center">No matches found for the selected date</div>
    </div>
</template>

<script>
var count = 0;
    import { Fragment } from 'vue-fragment'
    import CountryLeague from './CountryLeague'
    import moment from 'moment'
    import {mapActions, mapGetters, mapMutations} from 'vuex'
    import Loader from '../../Loader'
    import HorizontalLoader from '../../HorizontalLoader'
    export default {
        name: 'DateMatches',
        data() {
            return {
                loading: true,
                displayOnlyImportantLeagues: this.$route.name === 'home',
                displayAllLeagues:false,
                mainLeagues:[],
                restLeagues:[],
                height: 0,
                loader: false,
                count : 0
            }
        },
        props: {
            date: { // (:date)
                type: String
            }
        },

        computed: {
            ...mapGetters(['dateMatches','dateMatchesRest']),
            dateString() {
                return this.date ? moment(this.date).format('YYYY-MM-DD') : moment(Date.now()).format('YYYY-MM-DD')
            },
            formattedDate() {
                return moment(this.dateString).format('DD MMM YYYY')
            },
            leagueLoading() {
                return this.dateMatchesLoading || this.dateMatchesBetsLoading
            },
        },
        watch: {
            date() {
                if(moment().diff(this.date,'days') ===0){
                    this.displayOnlyImportantLeagues =true;
                    this.displayAllLeagues = false;
                } else{
                    this.displayOnlyImportantLeagues =false;
                    this.displayAllLeagues = true;
                }

                this.fetchData()
            },

            dateMatches(val){
                const dateFormat = 'YYYY-MM-DD HH:mm:ss';
                this.mainLeagues =[];
                this.restLeagues = [];
                for (let country in val.data) {
                    let country_main_leagues=[];
                    let country_rest_leagues=[];
                    for(let league in val.data[country]['leagues']){
                        if(val.data[country]['leagues'][league].important === 1){
                            this.mainLeagues.push({
                                name:val.data[country].name,
                                active: val.data[country].active,
                                location_id: val.data[country].location_id,
                                iso_2: val.data[country].iso_2,
                                sort_weight: val.data[country]['leagues'][league].sort_weight,
                                league:{
                                    id   : val.data[country]['leagues'][league].id,
                                    name : val.data[country]['leagues'][league].name,
                                    img  :  val.data[country]['leagues'][league].img,
                                    important :val.data[country]['leagues'][league].important,
                                    sort_weight:val.data[country]['leagues'][league].sort_weight,
                                    matches:   val.data[country]['leagues'][league].matches.sort((a, b) => {
                                        return moment(a.fixture_start_date, dateFormat, true).format() < moment(b.fixture_start_date, dateFormat, true).format() ? -1 : 1
                                    })
                                }
                            });
                        } else{
                         /*   this.restLeagues.push({
                                name:val.data[country].name,
                                active:val.data[country].active,
                                location_id:val.data[country].location_id,
                                iso_2:val.data[country].iso_2,
                                sort_weight:val.data[country]['leagues'][league].sort_weight,
                                league:{
                                    id   : val.data[country]['leagues'][league].id,
                                    name : val.data[country]['leagues'][league].name,
                                    img  :  val.data[country]['leagues'][league].img,
                                    important :1,
                                    sort_weight:val.data[country]['leagues'][league].sort_weight,
                                    matches:   val.data[country]['leagues'][league].matches.sort((a, b) => {
                                        return moment(a.fixture_start_date, dateFormat, true).format() < moment(b.fixture_start_date, dateFormat, true).format() ? -1 : 1
                                    })
                                }
                            });*/
                        }
                    }
                }
            },
            dateMatchesRest(val){
                const dateFormat = 'YYYY-MM-DD HH:mm:ss';
                this.restLeagues = [];
                for (let country in val.data) {
                    let country_main_leagues=[];
                    let country_rest_leagues=[];
                    for(let league in val.data[country]['leagues']){
                        if(val.data[country]['leagues'][league].important === 1){
                          /*  this.mainLeagues.push({
                                name:val.data[country].name,
                                active: val.data[country].active,
                                location_id: val.data[country].location_id,
                                iso_2: val.data[country].iso_2,
                                sort_weight: val.data[country]['leagues'][league].sort_weight,
                                league:{
                                    id   : val.data[country]['leagues'][league].id,
                                    name : val.data[country]['leagues'][league].name,
                                    img  :  val.data[country]['leagues'][league].img,
                                    important :val.data[country]['leagues'][league].important,
                                    sort_weight:val.data[country]['leagues'][league].sort_weight,
                                    matches:   val.data[country]['leagues'][league].matches.sort((a, b) => {
                                        return moment(a.fixture_start_date, dateFormat, true).format() < moment(b.fixture_start_date, dateFormat, true).format() ? -1 : 1
                                    })
                                }
                            });*/
                        } else{
                            this.restLeagues.push({
                                name:val.data[country].name,
                                active:val.data[country].active,
                                location_id:val.data[country].location_id,
                                iso_2:val.data[country].iso_2,
                                sort_weight:val.data[country]['leagues'][league].sort_weight,
                                league:{
                                    id   : val.data[country]['leagues'][league].id,
                                    name : val.data[country]['leagues'][league].name,
                                    img  :  val.data[country]['leagues'][league].img,
                                    important :1,
                                    sort_weight:val.data[country]['leagues'][league].sort_weight,
                                    matches:   val.data[country]['leagues'][league].matches.sort((a, b) => {
                                        return moment(a.fixture_start_date, dateFormat, true).format() < moment(b.fixture_start_date, dateFormat, true).format() ? -1 : 1
                                    })
                                }
                            });
                        }
                    }
                }
            }

        },
        created() {
            this.$root.$on('date-matches-loading', () => {
                this.loading = true;
                this.clearDateMatches()
            });
            this.fetchData()
        },
        methods: {
            ...mapActions(['fetchDateMatches', 'clearDateMatches','fetchDateMatchesRest','clearDateMatchesRest','fetchDateMatchesMain','updateDateMatchesAverage','updateDateMatchesTrackerAverage']),

            fetchData() {
                this.loading = true;
                this.loader = false;
                this.clearDateMatches();
                if(moment().diff(this.date,'days') <= 0){
                    this.fetchDateMatchesMain(this.date).finally(() => {
                     //   this.$log.debug('this.dateMatches', this.dateMatches)
                        this.loading = false
                        this.$forceUpdate()
                    });
                } else{
                    this.fetchDateMatches(this.date).finally(() => {
                   //     this.$log.debug('this.dateMatches', this.dateMatches)
                        this.loading = false;
                        this.$forceUpdate()
                    });
                }

            },
            fetchDataRest() {
                // this.clearDateMatchesRest();
                this.fetchDateMatchesRest(this.date).finally(() => {
                    //    this.$log.debug('this.dateMatches', this.dateMatches)
                    this.displayOnlyImportantLeagues = false;
                    this.$forceUpdate();
                    this.displayAllLeagues = true;

                });

            },
            showAllLeagues() {
                this.fetchDataRest();
            },
            displayCountry(country) {
                if (!this.displayOnlyImportantLeagues) {
                    return true
                }
                return !country.leagues.every(league => !league.important)
            },
            sortLeagues(country){
                // this.$log.debug(country.leagues)
                return  _.orderBy(country.leagues, ['sort_weight','name'],['desc','asc']);
            },
            sortWeightName(country){
                // this.$log.debug(country.leagues)
                return  _.orderBy(country, ['sort_weight','name'],['desc','asc']);
            },
            sortNameCountries(country){
                // this.$log.debug(country.leagues)
                return  _.orderBy(country, ['name'],['asc']);
            },
            getKey(key){
                return key*1000 + 1000;
            },
            onScroll() {
                this.windowTop = window.top.scrollY /* or: e.target.documentElement.scrollTop */
                this.maxHeight = document.body.scrollHeight;
                    if((window.innerHeight + this.windowTop + 466) >= (this.maxHeight)  ){
                        if(this.count === 0){
                            this.loader = true;
                            setTimeout(()=>{
                            this.loader = false;
                        },4000)
                        this.fetchDataRest();
                        this.count = this.count+1;
                    }
                }
            },
        },
        mounted() {
            window.addEventListener("scroll", this.onScroll);
            window.Echo.channel(`jokerodds_database_presence-bets-average`)
                .listen('BetsUpdatedAverage', (response) => {
                    console.log('updateDateMatchesAverage--');
                    this.$store.dispatch('updateDateMatchesAverage',response.bets);
                    this.$store.dispatch('updateDateMatchesTrackerAverage',response.bets);
                });

            window.Echo.channel(`jokerodds_database_presence-scores-updated`).listen('EventsScores', (response) => {
              //  console.log('ScoresUpdatedDateMatches--',response.data);
                this.$store.dispatch('updateDateMatchesScores',response.data);
            });

        },
        destroyed() {
            window.Echo.leave(`jokerodds_database_presence-bets-average`);
            window.Echo.leave(`jokerodds_database_presence-scores-updated`);
        },

        components: {HorizontalLoader, Loader, CountryLeague, Fragment},
    }
</script>

<style scoped>
    .no-matches {
        font-size: 18px;
        padding: 24px 12px
    }
    .loader-wrapper {
        padding: 24px 12px;
        display: flex;
        align-items: center;
        justify-content: center;
    }
    .lds-roller {
        display: inline-block;
        position: relative;
        width: 80px;
        height: 80px;
    }
    .lds-roller div {
        animation: lds-roller 1.2s cubic-bezier(0.5, 0, 0.5, 1) infinite;
        transform-origin: 40px 40px;
    }
    .lds-roller div:after {
        content: " ";
        display: block;
        position: absolute;
        width: 7px;
        height: 7px;
        border-radius: 50%;
        background: #DE343A;
        margin: -4px 0 0 -4px;
    }
    .lds-roller div:nth-child(1) {
        animation-delay: -0.036s;
    }
    .lds-roller div:nth-child(1):after {
        top: 63px;
        left: 63px;
    }
    .lds-roller div:nth-child(2) {
        animation-delay: -0.072s;
    }
    .lds-roller div:nth-child(2):after {
        top: 68px;
        left: 56px;
    }
    .lds-roller div:nth-child(3) {
        animation-delay: -0.108s;
    }
    .lds-roller div:nth-child(3):after {
        top: 71px;
        left: 48px;
    }
    .lds-roller div:nth-child(4) {
        animation-delay: -0.144s;
    }
    .lds-roller div:nth-child(4):after {
        top: 72px;
        left: 40px;
    }
    .lds-roller div:nth-child(5) {
        animation-delay: -0.18s;
    }
    .lds-roller div:nth-child(5):after {
        top: 71px;
        left: 32px;
    }
    .lds-roller div:nth-child(6) {
        animation-delay: -0.216s;
    }
    .lds-roller div:nth-child(6):after {
        top: 68px;
        left: 24px;
    }
    .lds-roller div:nth-child(7) {
        animation-delay: -0.252s;
    }
    .lds-roller div:nth-child(7):after {
        top: 63px;
        left: 17px;
    }
    .lds-roller div:nth-child(8) {
        animation-delay: -0.288s;
    }
    .lds-roller div:nth-child(8):after {
        top: 56px;
        left: 12px;
    }
    @keyframes lds-roller {
        0% {
            transform: rotate(0deg);
        }
        100% {
            transform: rotate(360deg);
        }
    }

</style>
